package com.perforce.spark.browse;

import java.util.Map;

import spark.ModelAndView;
import spark.Request;
import spark.Response;

import com.perforce.p4java.exception.P4JavaException;
import com.perforce.p4java.server.IOptionsServer;
import com.perforce.spark.ErrorModel;
import com.perforce.spark.connection.ConnectionSession;
import com.perforce.spark.depot.DepotFactory;
import com.perforce.spark.navigation.NavBar;

public class BrowseControl extends ErrorModel {

	public static ModelAndView browse(Request request, Response response) {
		Map<String, Object> model;
		model = NavBar.attributes("browse", request);

		String base = request.pathInfo();
		base = (base.endsWith("/")) ? base : base + "/";

		BreadcrumbModel breadCrumb = new BreadcrumbModel(base);
		model.put("breadcrumb", breadCrumb.getList());

		try {
			IOptionsServer p4 = ConnectionSession.get(request, response);
			BrowseModel browse = new BrowseModel(p4, base);
			model.put("directories", browse.getDirs());
			model.put("files", browse.getFiles());
			model.put("summary", browse.getSummary());

			p4.disconnect();
		} catch (P4JavaException e) {
			return error(e);
		}

		return new ModelAndView(model, "/browse/page-items.html");
	}

	public static ModelAndView depots(Request request, Response response) {
		Map<String, Object> model;
		model = NavBar.attributes("browse", request);

		try {
			IOptionsServer p4 = ConnectionSession.get(request, response);
			model.put("depots", DepotFactory.listAll(p4));
		} catch (P4JavaException e) {
			return error(e);
		}

		return new ModelAndView(model, "/browse/page-depots.html");
	}
}